declare module "models/eaLog" {
    class EALog {
        static getInstance(): any;
        static setLogEnabled(logEnabled: boolean): void;
        static debug(message: string): void;
        static info(message: string, mandatory: boolean): void;
        static warn(message: string): void;
        static error(message: string): void;
        static assertCondition(condition: boolean, message: string): void;
    }
    export default EALog;
}
declare module "models/classes/siteCentricProperty" {
    class SiteCentricProperty {
        mJson: any;
        constructor(builder: any);
        getJson(): any;
        static Builder: {
            new (): {
                mainJson: Record<string, any>;
                set(key: string, ...values: any[]): any;
                build(): SiteCentricProperty;
            };
        };
    }
    export default SiteCentricProperty;
}
declare module "models/classes/siteCentricCFlag" {
    class SiteCentricCFlag {
        mJson: any;
        constructor(builder: any);
        getJson(): any;
        static Builder: {
            new (): {
                jsonUnderConstruction: Record<string, any>;
                set(key: string, ...values: any[]): any;
                build(): SiteCentricCFlag;
            };
        };
    }
    export default SiteCentricCFlag;
}
declare module "models/classes/action" {
    class Action {
        mJson: any;
        constructor(builder: any);
        getJson(): any;
        static Builder: {
            new (): {
                mainJson: Record<string, any>;
                outsJson: Record<string, any>;
                setReference(ref: string): any;
                setIn(inValue: string): any;
                addOut(...outs: string[]): any;
                build(): Action;
            };
        };
    }
    export default Action;
}
declare module "utils/helper" {
    import { Permission } from 'react-native';
    class Helper {
        static isHostValid(domain: string): boolean;
        static isPermissionGranted(permission: Permission): Promise<any>;
        static mergeProperties(...jsonObjects: Record<string, any>[]): Record<string, any>;
    }
    export default Helper;
}
declare module "models/eaGeneric" {
    import SiteCentricProperty from "models/classes/siteCentricProperty";
    import SiteCentricCFlag from "models/classes/siteCentricCFlag";
    import Action from "models/classes/action";
    class EaGeneric {
        mInternals: any;
        mPages: any;
        mProperties: any;
        constructor(builder: any);
        getJson(): Record<string, any>;
        static Builder: {
            new (path: string): {
                properties: Record<string, any>;
                internals: Record<string, any>;
                pages: Record<string, any>;
                initInternalParams(): Record<string, any>;
                set(key: string, value: any): any;
                setLocation(latitude: Double, longitude: Double): any;
                setNewCustomer(newCustomer: boolean): any;
                setEmail(email: string): any;
                setPageGroup(group: string): any;
                setProfile(profile: string): any;
                setUID(uid: string): any;
                setAction(action: Action): any;
                setProperty(property: SiteCentricProperty): any;
                setCFlag(cflag: SiteCentricCFlag): any;
                build(): EaGeneric;
            };
            setAndroidInstallReferrer(value: string): void;
        };
    }
    export default EaGeneric;
}
declare module "utils/persistentIdentity" {
    class PersistentIdentity {
        static getValue(key: string): Promise<any>;
        static setValue(key: string, value: string): Promise<void>;
        static shouldFetchInstallReferrer(): Promise<boolean>;
        static isInstallReferrerSent(): Promise<boolean>;
        static getInstallReferrer(): Promise<any>;
        static getAdvertisingId(): Promise<any>;
        static getAdvertisingIsLat(): Promise<boolean>;
        static saveInstallReferrer(value: string): Promise<void>;
        static shouldSendInstallReferrer(): Promise<boolean>;
        static setInstallReferrerSent(): Promise<void>;
    }
    export default PersistentIdentity;
}
declare module "utils/connectivityHelper" {
    class ConnectivityHelper {
        static isConnected(): Promise<any>;
    }
    export default ConnectivityHelper;
}
declare module "utils/config" {
    export const MAX_UNZIPPED_BYTES_PER_SEND = 100000;
    export const POST_FAILED_RETRY_DELAY_MILLIS = 5000;
    export const NO_INTERNET_RETRY_DELAY_MILLIS = 60000;
}
declare module "utils/fileHelper" {
    class FileHelper {
        static getLines(): Promise<any>;
        static deleteLines(numberOfLineToDelete: number): void;
        static appendLine(newLine: string): void;
    }
    export default FileHelper;
}
declare module "utils/httpHelper" {
    class HttpHelper {
        static postData(value: string): Promise<boolean>;
    }
    export default HttpHelper;
}
declare module "utils/storedPropertiesTracker" {
    class StoredPropertiesTracker {
        static run(): Promise<void>;
        static postStoredProperties(storedProperties: string[]): Promise<number>;
    }
    export default StoredPropertiesTracker;
}
declare module "utils/propertiesTracker" {
    class PropertiesTracker {
        static run(properties: any): Promise<void>;
    }
    export default PropertiesTracker;
}
declare module "index" {
    import EaGeneric from "models/eaGeneric";
    class EAnalytics {
        static init(host: string, log: boolean): Promise<void>;
        static track(properties: EaGeneric | null): void;
        static getSrtDomain(): string;
        static getEventEmitter(): any;
        static getAdInfoIsLAT(): boolean;
        static getAdInfoId(): string;
    }
    export default EAnalytics;
}
