var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define("models/eaLog", ["require", "exports", "react-native-logs"], function (require, exports, react_native_logs_1) {
    "use strict";
    exports.__esModule = true;
    var log = react_native_logs_1.logger.createLogger();
    var LOG_ENABLED = false;
    var EALog = /** @class */ (function () {
        function EALog() {
        }
        EALog.getInstance = function () {
            if (log == null)
                log = react_native_logs_1.logger.createLogger();
            return log;
        };
        EALog.setLogEnabled = function (logEnabled) {
            LOG_ENABLED = logEnabled;
        };
        EALog.debug = function (message) {
            log.debug(message);
        };
        EALog.info = function (message, mandatory) {
            if (LOG_ENABLED || mandatory)
                log.info((mandatory ? "Eulerian Analytics : " : "") + message);
        };
        EALog.warn = function (message) {
            log.warn(message);
        };
        EALog.error = function (message) {
            log.error(message);
        };
        EALog.assertCondition = function (condition, message) {
            if (condition) {
                return;
            }
            else {
                throw new Error(message);
            }
        };
        return EALog;
    }());
    exports["default"] = EALog;
});
define("models/classes/siteCentricProperty", ["require", "exports"], function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var SiteCentricProperty = /** @class */ (function () {
        function SiteCentricProperty(builder) {
            this.mJson = builder.mainJson;
        }
        SiteCentricProperty.prototype.getJson = function () {
            return this.mJson;
        };
        SiteCentricProperty.Builder = /** @class */ (function () {
            function class_1() {
                this.mainJson = {};
            }
            class_1.prototype.set = function (key) {
                var values = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    values[_i - 1] = arguments[_i];
                }
                var jsonArray = [];
                for (var _a = 0, values_1 = values; _a < values_1.length; _a++) {
                    var value = values_1[_a];
                    jsonArray.push(value);
                }
                this.mainJson[key] = jsonArray;
                return this;
            };
            class_1.prototype.build = function () {
                if (Object.keys(this.mainJson).length === 0) {
                    var clzName = 'SiteCentricProperty';
                    console.warn("".concat(clzName, ": You might want to provide at least one key to make ").concat(clzName, " valid."));
                }
                return new SiteCentricProperty(this);
            };
            return class_1;
        }());
        return SiteCentricProperty;
    }());
    exports["default"] = SiteCentricProperty;
});
define("models/classes/siteCentricCFlag", ["require", "exports"], function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var SiteCentricCFlag = /** @class */ (function () {
        function SiteCentricCFlag(builder) {
            this.mJson = builder.jsonUnderConstruction;
        }
        SiteCentricCFlag.prototype.getJson = function () {
            return this.mJson;
        };
        SiteCentricCFlag.Builder = /** @class */ (function () {
            function class_2() {
                this.jsonUnderConstruction = {};
            }
            class_2.prototype.set = function (key) {
                var values = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    values[_i - 1] = arguments[_i];
                }
                var jsonArray = [];
                for (var _a = 0, values_2 = values; _a < values_2.length; _a++) {
                    var value = values_2[_a];
                    jsonArray.push(value);
                }
                this.jsonUnderConstruction[key] = jsonArray;
                return this;
            };
            class_2.prototype.build = function () {
                if (Object.keys(this.jsonUnderConstruction).length === 0) {
                    var clzName = 'SiteCentricCFlag';
                    console.warn("".concat(clzName, ": You might want to provide at least one set of key values to make ").concat(clzName, " valid."));
                }
                return new SiteCentricCFlag(this);
            };
            return class_2;
        }());
        return SiteCentricCFlag;
    }());
    exports["default"] = SiteCentricCFlag;
});
define("models/classes/action", ["require", "exports"], function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var Action = /** @class */ (function () {
        function Action(builder) {
            this.mJson = builder.mainJson;
        }
        Action.prototype.getJson = function () {
            return this.mJson;
        };
        Action.Builder = /** @class */ (function () {
            function class_3() {
                this.mainJson = {};
                this.outsJson = [];
            }
            class_3.prototype.setReference = function (ref) {
                this.mainJson.ref = ref;
                return this;
            };
            class_3.prototype.setIn = function (inValue) {
                this.mainJson["in"] = inValue;
                return this;
            };
            class_3.prototype.addOut = function () {
                var _a;
                var outs = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    outs[_i] = arguments[_i];
                }
                (_a = this.outsJson).push.apply(_a, outs);
                return this;
            };
            class_3.prototype.build = function () {
                if (this.outsJson.length > 0) {
                    this.mainJson.out = this.outsJson;
                }
                if (!this.mainJson["in"] && (!this.mainJson.out || this.mainJson.out.length === 0)) {
                    console.warn('Action: One of setIn() or addOut() method must be called to create a valid Action.');
                }
                return new Action(this);
            };
            return class_3;
        }());
        return Action;
    }());
    exports["default"] = Action;
});
define("utils/helper", ["require", "exports", "react-native"], function (require, exports, react_native_1) {
    "use strict";
    exports.__esModule = true;
    var reg = new RegExp("^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\\-]*[a-zA-Z0-9])\\.)*" +
        "([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\\-]*[A-Za-z0-9])$");
    var Helper = /** @class */ (function () {
        function Helper() {
        }
        Helper.isHostValid = function (domain) {
            return reg.test(domain);
        };
        Helper.isPermissionGranted = function (permission) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, react_native_1.PermissionsAndroid.check(permission)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Helper.mergeProperties = function () {
            var jsonObjects = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                jsonObjects[_i] = arguments[_i];
            }
            var merged = {};
            jsonObjects.forEach(function (json) {
                Object.keys(json).forEach(function (key) {
                    merged[key] = json[key];
                });
            });
            return merged;
        };
        return Helper;
    }());
    exports["default"] = Helper;
});
define("models/eaGeneric", ["require", "exports", "react-native", "..", "react-native-device-info", "utils/helper"], function (require, exports, react_native_2, __1, react_native_device_info_1, helper_1) {
    "use strict";
    exports.__esModule = true;
    var KEY_INSTALL_REFERRER = "ea-android-referrer";
    var KEY_EOS = "eos";
    var KEY_EHW = "ehw";
    var KEY_EHW_IDENTIFIER = "ehw-identifier";
    var KEY_ADINFO_IS_LAT = "ea-android-islat";
    var KEY_EUIDL = "euidl";
    var KEY_URL = "url";
    var KEY_APPNAME = "ea-appname";
    var KEY_ADINFO_ID = "ea-android-adid";
    var KEY_EPOCH = "ereplay-time";
    var KEY_APP_VERSION_NAME = "ea-appversion";
    var KEY_APP_VERSION_CODE = "ea-appversionbuild";
    var KEY_IS_TV = "ea-apptv";
    var KEY_MAC = "ea-android-mac";
    var KEY_SDK_VERSION = "ea-android-sdk-version";
    var KEY_PAGE_CFLAG = "cflag";
    var KEY_IDFV = "ea-ios-idfv";
    var KEY_IDFA = "ea-ios-idfa";
    var KEY_ADTRACKING_ENABLED = "ea-ios-islat";
    //- page keys
    var KEY_PAGE_LATITUDE = "ea-lat";
    var KEY_PAGE_LONGITUDE = "ea-lon";
    var KEY_PAGE_PATH = "path";
    var KEY_PAGE_EMAIL = "email";
    var KEY_PAGE_UID = "uid";
    var KEY_PAGE_PROFILE = "profile";
    var KEY_PAGE_GROUP = "pagegroup";
    var KEY_PAGE_ACTION = "action";
    var KEY_PAGE_PROPERTY = "property";
    var KEY_PAGE_NEW_CUSTOMER = "newcustomer";
    var androidInstallReferrer = null;
    var EaGeneric = /** @class */ (function () {
        function EaGeneric(builder) {
            this.mInternals = builder.internals;
            this.mPages = builder.pages;
            this.mProperties = builder.properties;
        }
        EaGeneric.prototype.getJson = function () {
            return helper_1["default"].mergeProperties(this.mInternals, this.mPages, this.mProperties);
        };
        EaGeneric.Builder = /** @class */ (function () {
            function class_4(path) {
                this.properties = {};
                this.internals = {};
                this.pages = {};
                this.initInternalParams();
                if (!path.startsWith('/')) {
                    path = '/' + path;
                }
                this.pages.path = path;
            }
            class_4.prototype.initInternalParams = function () {
                //this.internals["edebug"] = "on";
                var _this = this;
                this.internals[KEY_EOS] = react_native_2.Platform.OS === "android" ? "Android" : "" + react_native_device_info_1["default"].getSystemVersion();
                if (react_native_2.Platform.OS === "android") {
                    var self_1 = this;
                    react_native_device_info_1["default"].getManufacturer().then(function (manufacturer) {
                        self_1.internals[KEY_EHW] = manufacturer;
                    });
                    react_native_device_info_1["default"].getAndroidId().then(function (androidId) {
                        self_1.internals[KEY_EUIDL] = androidId;
                    });
                    react_native_device_info_1["default"].getMacAddress().then(function (mac) {
                        self_1.internals[KEY_MAC] = mac;
                    });
                    //this.internals[KEY_EHW] = DeviceInfo.getManufacturer().then().getManufacturerSync() + " " + DeviceInfo.getModel();
                    //this.internals[KEY_EUIDL] = DeviceInfo.getAndroidIdSync();
                    //this.internals[KEY_MAC] = DeviceInfo.getMacAddressSync();
                    //params[KEY_SDK_VERSION] = ""; //TODO?
                    if (androidInstallReferrer) {
                        self_1.internals[KEY_INSTALL_REFERRER] = androidInstallReferrer;
                    }
                }
                else {
                    this.internals[KEY_EHW] = react_native_device_info_1["default"].getModel();
                    this.internals[KEY_EHW_IDENTIFIER] = react_native_device_info_1["default"].getDeviceId();
                    react_native_device_info_1["default"].getUniqueId().then(function (uniqueId) {
                        _this.internals[KEY_IDFV] = uniqueId;
                    });
                }
                this.internals[react_native_2.Platform.OS === "android" ? KEY_ADINFO_ID : KEY_IDFA] = __1["default"].getAdInfoId();
                this.internals[react_native_2.Platform.OS === "android" ? KEY_ADINFO_IS_LAT : KEY_ADTRACKING_ENABLED] = __1["default"].getAdInfoIsLAT();
                /*DeviceInfo.getInstallerPackageName().then((installerPackageName) => {
                  let appName = installerPackageName;
                  this.internals[KEY_APPNAME] = appName;
                  this.internals[KEY_URL] = "http://" + appName;
                });*/
                var appName = "am1.eulerian.net/andrea/test";
                this.internals[KEY_APPNAME] = appName;
                this.internals[KEY_URL] = "http://" + appName;
                this.internals[KEY_EPOCH] = Math.floor(Date.now() / 1000);
                this.internals[KEY_APP_VERSION_CODE] = react_native_device_info_1["default"].getBuildNumber();
                this.internals[KEY_APP_VERSION_NAME] = react_native_device_info_1["default"].getVersion();
                return this.internals;
            };
            class_4.prototype.set = function (key, value) {
                this.properties[key] = value;
                return this;
            };
            class_4.setAndroidInstallReferrer = function (value) {
                androidInstallReferrer = value;
            };
            class_4.prototype.setLocation = function (latitude, longitude) {
                this.pages.latitude = latitude;
                this.pages.longitude = longitude;
                return this;
            };
            class_4.prototype.setNewCustomer = function (newCustomer) {
                if (newCustomer) {
                    this.pages.newcustomer = '1';
                }
                return this;
            };
            class_4.prototype.setEmail = function (email) {
                if (email) {
                    this.pages.email = email;
                }
                return this;
            };
            class_4.prototype.setPageGroup = function (group) {
                if (group) {
                    this.pages.pagegroup = group;
                }
                return this;
            };
            class_4.prototype.setProfile = function (profile) {
                if (profile) {
                    this.pages.profile = profile;
                }
                return this;
            };
            class_4.prototype.setUID = function (uid) {
                if (uid) {
                    this.pages.uid = uid;
                }
                return this;
            };
            class_4.prototype.setAction = function (action) {
                if (action) {
                    this.pages.action = action.getJson();
                }
                return this;
            };
            class_4.prototype.setProperty = function (property) {
                if (property) {
                    this.pages.property = property.getJson();
                }
                return this;
            };
            class_4.prototype.setCFlag = function (cflag) {
                if (cflag) {
                    this.pages.cflag = cflag.getJson();
                }
                return this;
            };
            class_4.prototype.build = function () {
                return new EaGeneric(this);
            };
            return class_4;
        }());
        return EaGeneric;
    }());
    exports["default"] = EaGeneric;
});
define("utils/persistentIdentity", ["require", "exports", "@react-native-async-storage/async-storage"], function (require, exports, async_storage_1) {
    "use strict";
    exports.__esModule = true;
    var INSTALL_REFERRER_HAS_ALREADY_BEEN_SENT_ONCE = "referrer_sent_v1_8_0";
    var KEY_REFERRER = "referrer";
    var KEY_ADVERTISING_ID = "id";
    var KEY_ADVERTISING_IS_LAT = "isLAT";
    var PersistentIdentity = /** @class */ (function () {
        function PersistentIdentity() {
        }
        PersistentIdentity.getValue = function (key) {
            return __awaiter(this, void 0, void 0, function () {
                var value, error_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, async_storage_1["default"].getItem(key)];
                        case 1:
                            value = _a.sent();
                            return [2 /*return*/, value];
                        case 2:
                            error_1 = _a.sent();
                            console.error('Errore nel recupero dei dati:', error_1);
                            return [2 /*return*/, null];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        PersistentIdentity.setValue = function (key, value) {
            return __awaiter(this, void 0, void 0, function () {
                var error_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, async_storage_1["default"].setItem(key, value)];
                        case 1:
                            _a.sent();
                            console.info('Salvato il dato:', key, ' con valore:', value);
                            return [3 /*break*/, 3];
                        case 2:
                            error_2 = _a.sent();
                            console.error('Errore nel salvataggio dei dati:', error_2);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        PersistentIdentity.shouldFetchInstallReferrer = function () {
            return __awaiter(this, void 0, void 0, function () {
                var value;
                return __generator(this, function (_a) {
                    value = this.getValue(INSTALL_REFERRER_HAS_ALREADY_BEEN_SENT_ONCE);
                    return [2 /*return*/, value != null && Boolean(value)];
                });
            });
        };
        PersistentIdentity.isInstallReferrerSent = function () {
            return __awaiter(this, void 0, void 0, function () {
                var value;
                return __generator(this, function (_a) {
                    value = this.getValue(INSTALL_REFERRER_HAS_ALREADY_BEEN_SENT_ONCE);
                    if (value != null)
                        return [2 /*return*/, Boolean(value)];
                    else
                        return [2 /*return*/, false];
                    return [2 /*return*/];
                });
            });
        };
        PersistentIdentity.getInstallReferrer = function () {
            return __awaiter(this, void 0, void 0, function () {
                var value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getValue(KEY_REFERRER)];
                        case 1:
                            value = _a.sent();
                            return [2 /*return*/, value];
                    }
                });
            });
        };
        PersistentIdentity.getAdvertisingId = function () {
            return __awaiter(this, void 0, void 0, function () {
                var value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getValue(KEY_ADVERTISING_ID)];
                        case 1:
                            value = _a.sent();
                            return [2 /*return*/, value];
                    }
                });
            });
        };
        PersistentIdentity.getAdvertisingIsLat = function () {
            return __awaiter(this, void 0, void 0, function () {
                var value;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getValue(KEY_ADVERTISING_IS_LAT)];
                        case 1:
                            value = _a.sent();
                            if (value != null)
                                return [2 /*return*/, Boolean(value)];
                            else
                                return [2 /*return*/, false];
                            return [2 /*return*/];
                    }
                });
            });
        };
        PersistentIdentity.saveInstallReferrer = function (value) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.setValue(KEY_REFERRER, value);
                    return [2 /*return*/];
                });
            });
        };
        PersistentIdentity.shouldSendInstallReferrer = function () {
            return __awaiter(this, void 0, void 0, function () {
                var isInstallReferrerSent, isInstallReferrerAvailable;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.isInstallReferrerSent()];
                        case 1:
                            isInstallReferrerSent = _a.sent();
                            return [4 /*yield*/, this.getInstallReferrer()];
                        case 2:
                            isInstallReferrerAvailable = _a.sent();
                            return [2 /*return*/, isInstallReferrerAvailable && (isInstallReferrerSent == null || !Boolean(isInstallReferrerSent))];
                    }
                });
            });
        };
        PersistentIdentity.setInstallReferrerSent = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.setValue(INSTALL_REFERRER_HAS_ALREADY_BEEN_SENT_ONCE, "true");
                    return [2 /*return*/];
                });
            });
        };
        return PersistentIdentity;
    }());
    exports["default"] = PersistentIdentity;
});
define("utils/connectivityHelper", ["require", "exports", "@react-native-community/netinfo"], function (require, exports, netinfo_1) {
    "use strict";
    exports.__esModule = true;
    var ConnectivityHelper = /** @class */ (function () {
        function ConnectivityHelper() {
        }
        ConnectivityHelper.isConnected = function () {
            return __awaiter(this, void 0, void 0, function () {
                var isConnected;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, netinfo_1["default"].fetch().then(function (state) {
                                return Boolean(state.isConnected);
                            })];
                        case 1:
                            isConnected = _a.sent();
                            return [2 /*return*/, isConnected];
                    }
                });
            });
        };
        return ConnectivityHelper;
    }());
    exports["default"] = ConnectivityHelper;
});
define("utils/config", ["require", "exports"], function (require, exports) {
    "use strict";
    exports.__esModule = true;
    exports.NO_INTERNET_RETRY_DELAY_MILLIS = exports.POST_FAILED_RETRY_DELAY_MILLIS = exports.MAX_UNZIPPED_BYTES_PER_SEND = void 0;
    exports.MAX_UNZIPPED_BYTES_PER_SEND = 100000;
    exports.POST_FAILED_RETRY_DELAY_MILLIS = 5000;
    exports.NO_INTERNET_RETRY_DELAY_MILLIS = 60000;
});
define("utils/fileHelper", ["require", "exports", "react-native-fs", "models/eaLog"], function (require, exports, RNFS, eaLog_1) {
    "use strict";
    exports.__esModule = true;
    var FILENAME = "eulerian.txt";
    var FILE_PATH = RNFS.DocumentDirectoryPath + '/' + FILENAME;
    var SEPARATOR = "\n";
    var FileHelper = /** @class */ (function () {
        function FileHelper() {
        }
        FileHelper.getLines = function () {
            return __awaiter(this, void 0, void 0, function () {
                var content, lines, res, error_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, RNFS.readFile(FILE_PATH, 'utf8')];
                        case 1:
                            content = _a.sent();
                            lines = content.split(SEPARATOR);
                            res = lines.filter(function (line) { return line.trim() !== ''; });
                            return [2 /*return*/, res];
                        case 2:
                            error_3 = _a.sent();
                            console.error('Errore nella lettura:', error_3);
                            return [2 /*return*/, []];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        FileHelper.deleteLines = function (numberOfLineToDelete) {
            RNFS.readFile(FILE_PATH, 'utf8')
                .then(function (currentContent) {
                var lines = currentContent.split(SEPARATOR);
                lines.splice(0, numberOfLineToDelete);
                var newContent = lines.join(SEPARATOR);
                return RNFS.writeFile(FILE_PATH, newContent, 'utf8');
            })
                .then(function () {
                eaLog_1["default"].debug('Deleted ' + numberOfLineToDelete + " lines.");
            })["catch"](function (error) {
                eaLog_1["default"].error('Unable to delete lines');
            });
        };
        FileHelper.appendLine = function (newLine) {
            RNFS.writeFile(FILE_PATH, newLine.concat(SEPARATOR), 'utf8')
                .then(function (success) {
                console.log('FILE WRITTEN!');
            })["catch"](function (err) {
                console.log(err.message);
            });
        };
        return FileHelper;
    }());
    exports["default"] = FileHelper;
});
define("utils/httpHelper", ["require", "exports", "models/eaLog", ".."], function (require, exports, eaLog_2, __2) {
    "use strict";
    exports.__esModule = true;
    var HttpHelper = /** @class */ (function () {
        function HttpHelper() {
        }
        HttpHelper.postData = function (value) {
            return __awaiter(this, void 0, void 0, function () {
                var sRTDomain, success;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            eaLog_2["default"].debug("-> posting data : " + value);
                            sRTDomain = __2["default"].getSrtDomain();
                            success = false;
                            if (!sRTDomain) return [3 /*break*/, 2];
                            return [4 /*yield*/, fetch(sRTDomain + (Math.floor(Date.now() / 1000)), {
                                    method: 'POST',
                                    headers: {
                                        //'Content-Encoding': 'gzip',
                                        'Content-Type': 'application/json'
                                    },
                                    //body: gzippedData,
                                    body: value
                                })
                                    .then(function (response) {
                                    // Gestisci la risposta qui
                                    eaLog_2["default"].debug("-> post response: " + JSON.stringify(response));
                                    if (!response.ok) {
                                        throw new Error('Errore nella richiesta.');
                                    }
                                    return response.json(); // Se la risposta è JSON
                                    //return response.ok;
                                })["catch"](function (error) {
                                    // Gestisci gli errori qui
                                    eaLog_2["default"].error(error);
                                    return false;
                                })];
                        case 1:
                            success = _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/, success];
                    }
                });
            });
        };
        return HttpHelper;
    }());
    exports["default"] = HttpHelper;
});
define("utils/storedPropertiesTracker", ["require", "exports", "utils/connectivityHelper", "models/eaLog", "..", "utils/config", "utils/fileHelper", "utils/httpHelper"], function (require, exports, connectivityHelper_1, eaLog_3, __3, config_1, fileHelper_1, httpHelper_1) {
    "use strict";
    exports.__esModule = true;
    var StoredPropertiesTracker = /** @class */ (function () {
        function StoredPropertiesTracker() {
        }
        StoredPropertiesTracker.run = function () {
            return __awaiter(this, void 0, void 0, function () {
                var storedProperties, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            eaLog_3["default"].debug("Tracking stored properties");
                            return [4 /*yield*/, !connectivityHelper_1["default"].isConnected()];
                        case 1:
                            if (_a.sent()) {
                                eaLog_3["default"].info("-> no network access. Properties is being stored and will be sent later.", true);
                                __3["default"].getEventEmitter().emit("message_retry", config_1.NO_INTERNET_RETRY_DELAY_MILLIS);
                            }
                            return [4 /*yield*/, fileHelper_1["default"].getLines()];
                        case 2:
                            storedProperties = _a.sent();
                            if (storedProperties.length == 0) {
                                eaLog_3["default"].debug("-> no properties stored.");
                                return [2 /*return*/];
                            }
                            eaLog_3["default"].debug("-> " + storedProperties.length + " stored properties found. Added for synchronization.");
                            return [4 /*yield*/, this.postStoredProperties(storedProperties)];
                        case 3:
                            result = _a.sent();
                            if (result == -1) {
                                __3["default"].getEventEmitter().emit("message_retry", config_1.POST_FAILED_RETRY_DELAY_MILLIS);
                            }
                            else {
                                eaLog_3["default"].debug("-> all properties tracked successfully. Stored properties is now empty.");
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        StoredPropertiesTracker.postStoredProperties = function (storedProperties) {
            return __awaiter(this, void 0, void 0, function () {
                var counter, jsonArray, line, lineJson, success, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            counter = 0;
                            jsonArray = [];
                            _a.label = 1;
                        case 1:
                            if (!(counter < storedProperties.length)) return [3 /*break*/, 9];
                            line = storedProperties[counter];
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 7, , 8]);
                            lineJson = JSON.parse(line);
                            jsonArray.push(lineJson);
                            if (!(counter === storedProperties.length - 1 || // Ultimo elemento
                                JSON.stringify(jsonArray).length + storedProperties[counter + 1].length > config_1.MAX_UNZIPPED_BYTES_PER_SEND)) return [3 /*break*/, 6];
                            return [4 /*yield*/, httpHelper_1["default"].postData(JSON.stringify(jsonArray))];
                        case 3:
                            success = _a.sent();
                            if (!success) return [3 /*break*/, 5];
                            return [4 /*yield*/, fileHelper_1["default"].deleteLines(jsonArray.length)];
                        case 4:
                            _a.sent();
                            jsonArray = []; // re-init in case the is still pending data.
                            eaLog_3["default"].debug('-> properties tracked !');
                            return [3 /*break*/, 6];
                        case 5:
                            // something went wrong, will try on track() next call. This avoid infinite loop.
                            eaLog_3["default"].debug('-> la sincronizzazione è fallita. Riproverà in seguito.');
                            return [2 /*return*/, -1];
                        case 6: return [3 /*break*/, 8];
                        case 7:
                            e_1 = _a.sent();
                            eaLog_3["default"].error("Errore nel codificare in JSON le propriet\u00E0: ".concat(line, ". Eccezione: ").concat(e_1));
                            return [3 /*break*/, 8];
                        case 8:
                            counter++;
                            return [3 /*break*/, 1];
                        case 9: return [2 /*return*/, counter];
                    }
                });
            });
        };
        return StoredPropertiesTracker;
    }());
    exports["default"] = StoredPropertiesTracker;
});
define("utils/propertiesTracker", ["require", "exports", "react-native", "utils/config", "utils/connectivityHelper", "models/eaLog", "utils/fileHelper", "utils/httpHelper", "utils/persistentIdentity", "utils/storedPropertiesTracker", "..", "models/eaGeneric"], function (require, exports, react_native_3, config_2, connectivityHelper_2, eaLog_4, fileHelper_2, httpHelper_2, persistentIdentity_1, storedPropertiesTracker_1, __4, eaGeneric_1) {
    "use strict";
    exports.__esModule = true;
    var PropertiesTracker = /** @class */ (function () {
        function PropertiesTracker() {
        }
        PropertiesTracker.run = function (properties) {
            return __awaiter(this, void 0, void 0, function () {
                var installReferrer, propertiesToString, storedProperties, success;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(react_native_3.Platform.OS === "android")) return [3 /*break*/, 3];
                            return [4 /*yield*/, persistentIdentity_1["default"].shouldSendInstallReferrer()];
                        case 1:
                            if (!_a.sent()) return [3 /*break*/, 3];
                            return [4 /*yield*/, persistentIdentity_1["default"].getInstallReferrer()];
                        case 2:
                            installReferrer = _a.sent();
                            eaLog_4["default"].debug("Tracking properties for the first time, add install referrer to it");
                            if (installReferrer) {
                                eaGeneric_1["default"].Builder.setAndroidInstallReferrer(installReferrer);
                                persistentIdentity_1["default"].setInstallReferrerSent();
                            }
                            _a.label = 3;
                        case 3:
                            propertiesToString = JSON.stringify(properties);
                            eaLog_4["default"].debug("Tracking properties");
                            return [4 /*yield*/, !connectivityHelper_2["default"].isConnected()];
                        case 4:
                            if (_a.sent()) {
                                eaLog_4["default"].info("-> no network access. Properties is being stored and will be sent later.", true);
                                fileHelper_2["default"].appendLine(propertiesToString);
                                __4["default"].getEventEmitter().emit("message_retry", config_2.NO_INTERNET_RETRY_DELAY_MILLIS);
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, fileHelper_2["default"].getLines()];
                        case 5:
                            storedProperties = _a.sent();
                            if (storedProperties.length == 0) {
                                eaLog_4["default"].debug("DEVO FARE LA CHIAMATA");
                                success = httpHelper_2["default"].postData("[" + propertiesToString + "]");
                                if (!success) {
                                    eaLog_4["default"].debug("-> synchronization failed. Will retry if no other pending track is found.");
                                    fileHelper_2["default"].appendLine(propertiesToString);
                                    __4["default"].getEventEmitter().emit("message_retry", config_2.POST_FAILED_RETRY_DELAY_MILLIS);
                                }
                                else {
                                    eaLog_4["default"].info("-> properties tracked !", true);
                                }
                                return [2 /*return*/];
                            }
                            eaLog_4["default"].debug("-> " + storedProperties.length + " stored properties found, current properties added to history to " +
                                "be sent with stored ones.");
                            fileHelper_2["default"].appendLine(propertiesToString); //we treat the current properties as a stored properties (history)
                            storedPropertiesTracker_1["default"].run();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return PropertiesTracker;
    }());
    exports["default"] = PropertiesTracker;
});
define("index", ["require", "exports", "react-native/Libraries/vendor/emitter/EventEmitter", "models/eaLog", "utils/helper", "utils/persistentIdentity", "@sparkfabrik/react-native-idfa-aaid", "react-native", "utils/storedPropertiesTracker", "react-native-play-install-referrer", "utils/propertiesTracker"], function (require, exports, EventEmitter_1, eaLog_5, helper_2, persistentIdentity_2, react_native_idfa_aaid_1, react_native_4, storedPropertiesTracker_2, react_native_play_install_referrer_1, propertiesTracker_1) {
    "use strict";
    exports.__esModule = true;
    var sRTDomain = null, sAdInfoId = null, sAdInfoIsLAT = false, initialized = false;
    var setAdvertisingInfo = function (info) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, persistentIdentity_2["default"].setValue('id', info.id)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, persistentIdentity_2["default"].setValue('isAdTrackingLimited', JSON.stringify(info.isAdTrackingLimited))];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); };
    var emitter = new EventEmitter_1["default"]();
    emitter.addListener("message_retry", function (delay) {
        setTimeout(function () {
            eaLog_5["default"].info("Retry strategy", false);
            EAnalytics.track(null);
        }, delay);
    });
    var EAnalytics = /** @class */ (function () {
        function EAnalytics() {
        }
        EAnalytics.init = function (host, log) {
            return __awaiter(this, void 0, void 0, function () {
                var shouldFetchInstallReferrer;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            eaLog_5["default"].setLogEnabled(log);
                            eaLog_5["default"].assertCondition(!initialized && sRTDomain == null, "Init must be called only once.");
                            eaLog_5["default"].assertCondition(!host.includes(".eulerian.com"), "Host cannot contain '.eulerian.com'.");
                            eaLog_5["default"].assertCondition(helper_2["default"].isHostValid(host), "Init failed : " + host + " is not a valid host name. " +
                                "For instance, test.example.net is a valid.");
                            initialized = true;
                            sRTDomain = "https://" + host + "/collectorjson/-/";
                            sAdInfoId = persistentIdentity_2["default"].getAdvertisingId().toString();
                            sAdInfoIsLAT = Boolean(persistentIdentity_2["default"].getAdvertisingIsLat());
                            eaLog_5["default"].info("SDK initialized with " + host, true);
                            react_native_idfa_aaid_1["default"].getAdvertisingInfo()
                                .then(function (res) {
                                setAdvertisingInfo(res);
                            })["catch"](function (err) {
                                console.log(err);
                            });
                            this.track(null);
                            if (!(react_native_4.Platform.OS == "android")) return [3 /*break*/, 2];
                            return [4 /*yield*/, persistentIdentity_2["default"].shouldFetchInstallReferrer()];
                        case 1:
                            shouldFetchInstallReferrer = _a.sent();
                            if (shouldFetchInstallReferrer) {
                                react_native_play_install_referrer_1.PlayInstallReferrer.getInstallReferrerInfo(function (installReferrerInfo, error) {
                                    if (!error) {
                                        if (installReferrerInfo) {
                                            persistentIdentity_2["default"].saveInstallReferrer(installReferrerInfo.installReferrer);
                                            console.log("Install referrer = " + installReferrerInfo.installReferrer);
                                            console.log("Referrer click timestamp seconds = " + installReferrerInfo.referrerClickTimestampSeconds);
                                            console.log("Install begin timestamp seconds = " + installReferrerInfo.installBeginTimestampSeconds);
                                            console.log("Referrer click timestamp server seconds = " + installReferrerInfo.referrerClickTimestampServerSeconds);
                                            console.log("Install begin timestamp server seconds = " + installReferrerInfo.installBeginTimestampServerSeconds);
                                            console.log("Install version = " + installReferrerInfo.installVersion);
                                            console.log("Google Play instant = " + installReferrerInfo.googlePlayInstant);
                                        }
                                        else {
                                            console.log("Failed to get install referrer info! Is null.");
                                        }
                                    }
                                    else {
                                        console.log("Failed to get install referrer info!");
                                        console.log("Response code: " + error.responseCode);
                                        console.log("Message: " + error.message);
                                    }
                                });
                            }
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        EAnalytics.track = function (properties) {
            eaLog_5["default"].assertCondition(sRTDomain != null, "The SDK has not been initialized. You must call EAnalytics" +
                ".init(Context, String) once.");
            if (properties == null) {
                storedPropertiesTracker_2["default"].run();
            }
            else {
                propertiesTracker_1["default"].run(properties.getJson());
            }
        };
        EAnalytics.getSrtDomain = function () {
            return sRTDomain;
        };
        EAnalytics.getEventEmitter = function () {
            return emitter;
        };
        EAnalytics.getAdInfoIsLAT = function () {
            return sAdInfoIsLAT;
        };
        EAnalytics.getAdInfoId = function () {
            return sAdInfoId;
        };
        return EAnalytics;
    }());
    exports["default"] = EAnalytics;
});
