"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Action {
    constructor(builder) {
        this.mJson = builder.mainJson;
    }
    getJson() {
        return this.mJson;
    }
}
Action.Builder = class {
    constructor() {
        this.mainJson = {};
        this.outsJson = [];
    }
    setReference(ref) {
        this.mainJson.ref = ref;
        return this;
    }
    setIn(inValue) {
        this.mainJson.in = inValue;
        return this;
    }
    addOut(...outs) {
        this.outsJson.push(...outs);
        return this;
    }
    build() {
        if (this.outsJson.length > 0) {
            this.mainJson.out = this.outsJson;
        }
        if (!this.mainJson.in && (!this.mainJson.out || this.mainJson.out.length === 0)) {
            console.warn('Action: One of setIn() or addOut() method must be called to create a valid Action.');
        }
        return new Action(this);
    }
};
exports.default = Action;
