"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const KEY_REF = "ref";
const KEY_NAME = "name";
const KEY_PARAMS = "params";
const KEY_GROUP = "group";
class Product {
    constructor(properties) {
        this.mJson = properties.mainJson;
    }
    getJson() {
        return this.mJson;
    }
}
Product.Builder = class {
    constructor(reference) {
        this.mainJson = {};
        this.mainJson[KEY_REF] = reference;
    }
    setName(name) {
        this.mainJson[KEY_NAME] = name;
        return this;
    }
    setGroup(group) {
        this.mainJson[KEY_GROUP] = group;
        return this;
    }
    setParams(params) {
        this.mainJson[KEY_PARAMS] = params.getJson();
        return this;
    }
    build() {
        return new Product(this);
    }
};
exports.default = Product;
