"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SiteCentricCFlag {
    constructor(builder) {
        this.mJson = builder.jsonUnderConstruction;
    }
    getJson() {
        return this.mJson;
    }
}
SiteCentricCFlag.Builder = class {
    constructor() {
        this.jsonUnderConstruction = {};
    }
    set(key, ...values) {
        const jsonArray = [];
        for (const value of values) {
            jsonArray.push(value);
        }
        this.jsonUnderConstruction[key] = jsonArray;
        return this;
    }
    build() {
        if (Object.keys(this.jsonUnderConstruction).length === 0) {
            const clzName = 'SiteCentricCFlag';
            console.warn(`${clzName}: You might want to provide at least one set of key values to make ${clzName} valid.`);
        }
        return new SiteCentricCFlag(this);
    }
};
exports.default = SiteCentricCFlag;
