"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SiteCentricProperty {
    constructor(builder) {
        this.mJson = builder.mainJson;
    }
    getJson() {
        return this.mJson;
    }
}
SiteCentricProperty.Builder = class {
    constructor() {
        this.mainJson = {};
    }
    set(key, ...values) {
        const jsonArray = [];
        for (const value of values) {
            jsonArray.push(value);
        }
        this.mainJson[key] = jsonArray;
        return this;
    }
    build() {
        if (Object.keys(this.mainJson).length === 0) {
            const clzName = 'SiteCentricProperty';
            console.warn(`${clzName}: You might want to provide at least one key to make ${clzName} valid.`);
        }
        return new SiteCentricProperty(this);
    }
};
exports.default = SiteCentricProperty;
