"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const eaGeneric_1 = __importDefault(require("./eaGeneric"));
const KEY_SCART = "scart";
const KEY_CUMUL = "scartcumul";
const KEY_AMOUNT = "amount";
const KEY_QUANTITY = "quantity";
const KEY_PRODUCTS = "products";
class EACart extends eaGeneric_1.default {
    constructor(properties) {
        super(properties);
        this.jsonProducts = properties.mainJson;
    }
}
EACart.Builder = class extends eaGeneric_1.default.Builder {
    constructor(path) {
        super(path);
        this.mainJson = [];
        super.set(KEY_SCART, "1");
    }
    setCartCumul(cumul) {
        super.set(KEY_CUMUL, cumul ? 1 : 0);
        return this;
    }
    addParam(key, value) {
        this.mainJson[key] = value;
        return this;
    }
    addProduct(product, amount, quantity) {
        const productJson = product.getJson();
        productJson[KEY_AMOUNT] = amount;
        productJson[KEY_QUANTITY] = quantity;
        this.mainJson.push(productJson);
        return this;
    }
    build() {
        var eaProducts = new EACart(this);
        super.set(KEY_PRODUCTS, eaProducts.jsonProducts);
        return eaProducts;
    }
};
exports.default = EACart;
