"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const eaGeneric_1 = __importDefault(require("./eaGeneric"));
class EAEstimate extends eaGeneric_1.default {
    constructor(builder) {
        super(builder);
        this.mJson = builder.mainJson;
    }
    getJson() {
        return this.mJson;
    }
}
EAEstimate.Builder = class extends eaGeneric_1.default.Builder {
    constructor(path) {
        super(path);
        this.mainJson = {};
        this.products = [];
        this.path = path;
        this.ref = "";
        this.init();
    }
    init() {
        this.set('estimate', '1');
    }
    setRef(ref) {
        this.set("ref", ref);
        return this;
    }
    set(key, value) {
        this.mainJson[key] = value;
        return this;
    }
    setAmount(amount) {
        this.set('amount', amount);
        return this;
    }
    setCurrency(currency) {
        this.set('currency', currency);
        return this;
    }
    setType(type) {
        this.set('type', type);
        return this;
    }
    addProduct(product, amount, quantity) {
        if (quantity <= 0) {
            console.warn(`EAEstimate: quantity might be > 0. Current is ${quantity}`);
        }
        const productJson = product.getJson();
        productJson.amount = amount.toString();
        productJson.quantity = quantity;
        this.products.push(productJson);
        return this;
    }
    build() {
        this.set('products', this.products);
        return new EAEstimate(this);
    }
};
exports.default = EAEstimate;
