"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_logs_1 = require("react-native-logs");
var log = react_native_logs_1.logger.createLogger();
var LOG_ENABLED = false;
class EALog {
    static getInstance() {
        if (log == null)
            log = react_native_logs_1.logger.createLogger();
        return log;
    }
    static setLogEnabled(logEnabled) {
        LOG_ENABLED = logEnabled;
    }
    static debug(message) {
        log.debug(message);
    }
    static info(message, mandatory) {
        if (LOG_ENABLED || mandatory)
            log.info((mandatory ? "Eulerian Analytics : " : "") + message);
    }
    static warn(message) {
        log.warn(message);
    }
    static error(message) {
        log.error(message);
    }
    static assertCondition(condition, message) {
        if (condition) {
            return;
        }
        else {
            throw new Error(message);
        }
    }
}
exports.default = EALog;
