"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const eaGeneric_1 = __importDefault(require("./eaGeneric"));
class EAOrder extends eaGeneric_1.default {
    constructor(builder) {
        super(builder);
    }
    getProperties() {
        return this.properties;
    }
}
EAOrder.Builder = class extends eaGeneric_1.default.Builder {
    constructor(path) {
        super(path);
        this.properties = {
            products: [],
        };
        this.path = path;
    }
    setRef(ref) {
        this.properties.ref = ref;
        return this;
    }
    setAmount(amount) {
        this.properties.amount = amount;
        return this;
    }
    setCurrency(currency) {
        this.properties.currency = currency;
        return this;
    }
    setType(type) {
        this.properties.type = type;
        return this;
    }
    setPayment(payment) {
        this.properties.payment = payment;
        return this;
    }
    setEstimateRef(estimateRef) {
        //this.properties.estimateref = estimateRef;
        return this;
    }
    addProduct(product, amount, quantity) {
        if (quantity <= 0) {
            console.warn(`EAOrder#addProduct(): quantity must be > 0. Current is ${quantity}`);
        }
        const productJson = product.getJson();
        productJson.amount = amount.toString();
        productJson.quantity = quantity;
        this.properties.products.push(productJson);
        return this;
    }
    getProperties() {
        return this.properties;
    }
    build() {
        return new EAOrder(this);
    }
};
exports.default = EAOrder;
