"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const RNFS = __importStar(require("react-native-fs"));
const eaLog_1 = __importDefault(require("../models/eaLog"));
const FILENAME = "eulerian.txt";
const FILE_PATH = RNFS.DocumentDirectoryPath + '/' + FILENAME;
const SEPARATOR = "\n";
class FileHelper {
    static getLines() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const content = yield RNFS.readFile(FILE_PATH, 'utf8');
                const lines = content.split(SEPARATOR);
                const res = lines.filter((line) => line.trim() !== '');
                return res;
            }
            catch (error) {
                console.error('Errore nella lettura:', error);
                return [];
            }
        });
    }
    static deleteLines(numberOfLineToDelete) {
        RNFS.readFile(FILE_PATH, 'utf8')
            .then((currentContent) => {
            const lines = currentContent.split(SEPARATOR);
            lines.splice(0, numberOfLineToDelete);
            const newContent = lines.join(SEPARATOR);
            return RNFS.writeFile(FILE_PATH, newContent, 'utf8');
        })
            .then(() => {
            eaLog_1.default.debug('Deleted ' + numberOfLineToDelete + " lines.");
        })
            .catch((error) => {
            eaLog_1.default.error('Unable to delete lines');
        });
    }
    static appendLine(newLine) {
        RNFS.writeFile(FILE_PATH, newLine.concat(SEPARATOR), 'utf8')
            .then((success) => {
            console.log('FILE WRITTEN!');
        })
            .catch((err) => {
            console.log(err.message);
        });
    }
}
exports.default = FileHelper;
