"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
var reg = new RegExp("^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\\-]*[a-zA-Z0-9])\\.)*" +
    "([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\\-]*[A-Za-z0-9])$");
class Helper {
    static isHostValid(domain) {
        return reg.test(domain);
    }
    static isPermissionGranted(permission) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield react_native_1.PermissionsAndroid.check(permission);
        });
    }
    static mergeProperties(...jsonObjects) {
        const merged = {};
        jsonObjects.forEach((json) => {
            Object.keys(json).forEach((key) => {
                merged[key] = json[key];
            });
        });
        return merged;
    }
}
exports.default = Helper;
