"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const eaLog_1 = __importDefault(require("../models/eaLog"));
const __1 = __importDefault(require(".."));
class HttpHelper {
    static postData(value) {
        return __awaiter(this, void 0, void 0, function* () {
            eaLog_1.default.debug("-> posting data : " + value);
            //const gzippedData = Gzip.zip(value);
            let sRTDomain = __1.default.getSrtDomain();
            let success = false;
            if (sRTDomain) {
                success = yield fetch(sRTDomain + (Math.floor(Date.now() / 1000)), {
                    method: 'POST',
                    headers: {
                        //'Content-Encoding': 'gzip',
                        'Content-Type': 'application/json',
                    },
                    //body: gzippedData,
                    body: value,
                })
                    .then((response) => {
                    // Gestisci la risposta qui
                    eaLog_1.default.debug("-> post response: " + JSON.stringify(response));
                    if (!response.ok) {
                        throw new Error('Errore nella richiesta.');
                    }
                    return response.json(); // Se la risposta è JSON
                    //return response.ok;
                })
                    .catch((error) => {
                    // Gestisci gli errori qui
                    eaLog_1.default.error(error);
                    return false;
                });
            }
            return success;
        });
    }
}
exports.default = HttpHelper;
